package PokeOS 
{
	import flash.events.TextEvent;
	import flash.text.Font;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Sfx;
	import net.flashpunk.tweens.misc.VarTween;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.World;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import PokeOS.Answer;
	import net.flashpunk.utils.Ease;
	import tony.BlackScreen;
	
	/**
	 * ...
	 * @author tony
	 */
	public class PokeOS extends Entity 
	{
		public var OPs : Vector.<PokeOP>;
		public var OP_index:int = 0;
		public var OP_return_pointer:int = 0;
		public var game_over:Boolean = false;
		
		public var display:Text = new Text("", 60, 155, { wordWrap:true, color:0x68c729, width:220, height:150 } );
		public var qbar_1:Text = new Text("1", 427, 190, { color:0x68c729, wordWrap:true, width:260, height:40 } );
		public var qbar_2:Text = new Text("2", 427, 246, { color:0x68c729, wordWrap:true, width:260, height:40 } );
		public var qbar_3:Text = new Text("3", 427, 303, { color:0x68c729, wordWrap:true, width:260, height:40 } );
		public var qbar_4:Text = new Text("4", 427, 360, { color:0x68c729, wordWrap:true, width:260, height:40 } );
		
		public var music : Sfx = new Sfx(Assets.music);
		
		public function PokeOS(ops:Vector.<PokeOP>)
		{
			music.loop();
			
			OPs = ops;
			addGraphic(display);
			addGraphic(qbar_1);
			addGraphic(qbar_2);
			addGraphic(qbar_3);
			addGraphic(qbar_4);
			
			Execute_OP();
		}
		
		public function Execute_this_OP(op:PokeOP):void
		{
			if (op is PokeOS.OP_YouAreFuckingWrong)
			{
				OP_return_pointer = OP_index;
				for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == "wrong")
						{
							OP_index = i;
							Execute_OP();
							new Sfx(Assets.sfx_wrong).play();
							return;
						}
					}
			}
		}
		
		public function Execute_OP():void
		{
			if (OPs[OP_index] is OP_Question)
			{
				display.text = "";
				qbar_1.text = "";
				qbar_2.text = "";
				qbar_3.text = "";
				qbar_4.text = "";
				
				var q:OP_Question = OPs[OP_index] as PokeOS.OP_Question;
				display.text = q.question;
				if (q.choices.length >= 1) qbar_1.text = q.choices[0].a;
				if (q.choices.length >= 2) qbar_2.text = q.choices[1].a;
				if (q.choices.length >= 3) qbar_3.text = q.choices[2].a;
				if (q.choices.length >= 4) qbar_4.text = q.choices[3].a;
				
				var displayTween:VarTween = new VarTween();
				display.alpha = 0;
				displayTween.tween(display, "alpha", 1, 10, Ease.quadIn);
				addTween(displayTween, true);
				
				var qbar_1Tween:VarTween = new VarTween();
				qbar_1.alpha = 0;
				qbar_1Tween.tween(qbar_1, "alpha", 1, 7, Ease.quadIn);
				addTween(qbar_1Tween , true);
				
				var qbar_2Tween:VarTween = new VarTween();
				qbar_2.alpha = 0;
				qbar_2Tween.tween(qbar_2, "alpha", 1, 7, Ease.quadIn);
				addTween(qbar_2Tween , true);
				
				var qbar_3Tween:VarTween = new VarTween();
				qbar_3.alpha = 0;
				qbar_3Tween.tween(qbar_3, "alpha", 1, 7, Ease.quadIn);
				addTween(qbar_3Tween , true);
				
				var qbar_4Tween:VarTween = new VarTween();
				qbar_4.alpha = 0;
				qbar_4Tween.tween(qbar_4, "alpha", 1, 7, Ease.quadIn);
				addTween(qbar_4Tween , true);
			}
			
			if (OPs[OP_index] is PokeOS.OP_CorrectAnswer)
			{
				OP_return_pointer = OP_index + 1;
				for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == "correct")
						{
							OP_index = i;
							Execute_OP();
							new Sfx(Assets.sfx_correct ).play();
							return;
						}
					}
			}
			
			if (OPs[OP_index] is PokeOS.OP_EndGame && game_over == false)
			{
				game_over = true;
				
				music.stop();
				new Sfx(Assets.SHOOK).play();
				
				display.text = "";
				qbar_1.text = "";
				qbar_2.text = "";
				qbar_3.text = "";
				qbar_4.text = "";
				
				var bl:BlackScreen = new BlackScreen();
				bl.fadeOut(700);
				world.add(bl);
				world.add(new ThunderwareLudumDare());
			}
		}
		
		public function Click_QBar_1():void
		{
			if (game_over) return;
			
			if (OPs[OP_index] is OP_Question)
			{
				var q:OP_Question = OPs[OP_index] as PokeOS.OP_Question;
				if (q.choices.length >= 1)
				{
					var link:String = q.choices[0].link;
					if (link == "next")
					{
						OP_index++;
						new Sfx(Assets.sfx_btn_click).play();
						Execute_OP();
						return;
					}
					if (link == "")
					{
						Execute_this_OP(new PokeOS.OP_YouAreFuckingWrong());
					}
					if (link == "return")
					{
						OP_index = OP_return_pointer;
						new Sfx(Assets.sfx_btn_click).play();
						Execute_OP();
						return;
					}
					for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == link)
						{
							OP_index = i;
							new Sfx(Assets.sfx_btn_click).play();
							Execute_OP();
							return;
						}
					}
				}
			}
		}
		
		public function Click_QBar_2():void
		{
			if (game_over) return;
			
			if (OPs[OP_index] is OP_Question)
			{
				var q:OP_Question = OPs[OP_index] as PokeOS.OP_Question;
				if (q.choices.length >= 2)
				{
					var link:String = q.choices[1].link;
					if (link == "next")
					{
						OP_index++;
						Execute_OP();
						new Sfx(Assets.sfx_btn_click).play();
						return;
					}
					if (link == "")
					{
						Execute_this_OP(new PokeOS.OP_YouAreFuckingWrong());
					}
					if (link == "return")
					{
						OP_index = OP_return_pointer;
						new Sfx(Assets.sfx_btn_click).play();
						Execute_OP();
						return;
					}
					for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == link)
						{
							OP_index = i;
							Execute_OP();
							new Sfx(Assets.sfx_btn_click).play();
							return;
						}
					}
				}
			}
		}
		
		public function Click_QBar_3():void
		{
			if (game_over) return;
			
			if (OPs[OP_index] is OP_Question)
			{
				var q:OP_Question = OPs[OP_index] as PokeOS.OP_Question;
				if (q.choices.length >= 3)
				{
					var link:String = q.choices[2].link;
					if (link == "next")
					{
						OP_index++;
						Execute_OP();
						new Sfx(Assets.sfx_btn_click).play();
						return;
					}
					if (link == "")
					{
						Execute_this_OP(new PokeOS.OP_YouAreFuckingWrong());
					}
					if (link == "return")
					{
						OP_index = OP_return_pointer;
						new Sfx(Assets.sfx_btn_click).play();
						Execute_OP();
						return;
					}
					for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == link)
						{
							OP_index = i;
							Execute_OP();
							new Sfx(Assets.sfx_btn_click).play();
							return;
						}
					}
				}
			}
		}
		
		public function Click_QBar_4():void
		{
			if (game_over) return;
			
			if (OPs[OP_index] is OP_Question)
			{
				var q:OP_Question = OPs[OP_index] as PokeOS.OP_Question;
				if (q.choices.length >= 4)
				{
					var link:String = q.choices[3].link;
					if (link == "next")
					{
						OP_index++;
						Execute_OP();
						new Sfx(Assets.sfx_btn_click).play();
						return;
					}
					if (link == "")
					{
						Execute_this_OP(new PokeOS.OP_YouAreFuckingWrong());
					}
					if (link == "return")
					{
						OP_index = OP_return_pointer;
						new Sfx(Assets.sfx_btn_click).play();
						Execute_OP();
						return;
					}
					for (var i:int = 0; i < OPs.length; i++)
					{
						var op:PokeOS.PokeOP = OPs[i];
						if (op.label == link)
						{
							OP_index = i;
							Execute_OP();
							new Sfx(Assets.sfx_btn_click).play();
							return;
						}
					}
				}
			}
		}
		
	}

}